;******************** (C) COPYRIGHT 2025 Sinowealth *****************************
;* File Name          : startup_sh30f9xx_sb0_iar.s
;* Author             : SINOWEALTH Application Team
;* Version            : V1.1
;* Date               : 2025-03-05
;* Description        : SH30F9 SB0 devices vector table for EWARM toolchain.
;*                      This module performs:
;*                      - Set the initial SP
;*                      - Set the initial PC == __iar_program_start,
;*                      - Set the vector table entries with the exceptions ISR 
;*                        address.
;*                      - Branches to main in the C library (which eventually
;*                        calls main()).
;*                      After Reset the Cortex-M0+ processor is in Thread mode,
;*                      priority is Privileged, and the Stack is set to Main.
;********************************************************************************
;* 
;* SINOWEALTH IS SUPPLYING THIS SOFTWARE FOR USE EXCLUSIVELY ON SINOWEALTH
;* MICROCONTROLLER PRODUCTS. IT IS PROTECTED UNDER APPLICABLE COPYRIGHT LAWS. 
;* THIS SOFTWARE IS FOR GUIDANCE IN ORDER TO SAVE TIME. AS A RESULT, SINOWEALTH 
;* SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES 
;* WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT OF SUCH FIRMWARE AND/OR
;* THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN 
;* CONNECTION WITH THEIR PRODUCTS.
;*
;* <h2><center>&copy; COPYRIGHT 2025 Sinowealth</center></h2>
;*
;********************************************************************************
;*
;
;
; The modules in this file are included in the libraries, and may be replaced
; by any user-defined modules that define the PUBLIC symbol _program_start or
; a user defined start symbol.
; To override the cstartup defined in the library, simply add your modified
; version to the workbench project.
;
; The vector table is normally located at address 0.
; When debugging in RAM, it can be located in RAM, aligned to at least 2^6.
; The name "__vector_table" has special meaning for C-SPY:
; it is where the SP start value is found, and the NVIC vector
; table register (VTOR) is initialized to this address if != 0.
;
; Cortex-M version




    MODULE  ?cstartup

    ;; Forward declaration of sections.
    SECTION CSTACK:DATA:NOROOT (3)

    SECTION .intvec:CODE:NOROOT (2)

    EXTERN  __iar_program_start
    PUBLIC  __vector_table

    DATA
__vector_table

     DCD      sfe(CSTACK)          ;/* -16 (000H) Top of Stack                                  */
     DCD      Reset_Handler        ;/* -15 (004H) Reset Handler                                 */
     DCD      NMI_Handler          ;/* -14 (008H) Non Maskable Interrupt                        */
     DCD      HardFault_Handler    ;/* -13 (00CH) Hard Fault Interrupt                          */
     DCD      Default_Handler      ;/* -12 (010H) Reserved                                      */
     DCD      Default_Handler      ;/* -11 (014H) Reserved                                      */
     DCD      Default_Handler      ;/* -10 (018H) Reserved                                      */
     DCD      Default_Handler      ;/*  -9 (01CH) Reserved                                      */
     DCD      Default_Handler      ;/*  -8 (020H) Reserved                                      */
     DCD      Default_Handler      ;/*  -7 (024H) Reserved                                      */
     DCD      Default_Handler      ;/*  -6 (028H) Reserved                                      */
     DCD      SVC_Handler          ;/*  -5 (02CH) SV Call Interrupt                             */
     DCD      Default_Handler      ;/*  -4 (030H) Reserved                                      */
     DCD      Default_Handler      ;/*  -3 (034H) Reserved                                      */
     DCD      PendSV_Handler       ;/*  -2 (038H) Pend SV Interrupt                             */
     DCD      SysTick_Handler      ;/*  -1 (03CH) System Tick Interrupt                         */
     DCD      WWDT_Handler         ;/*   0 (040H) WWDT Interrupt                                */
     DCD      BOD_Handler          ;/*   1 (044H) BOD Interrupt                                 */
     DCD      RCC_Handler          ;/*   2 (048H) RCC Interrupt                                 */
     DCD      EXTI0_Handler        ;/*   3 (04CH) EXTI0 Interrupt                               */
     DCD      EXTI1_Handler        ;/*   4 (050H) EXTI1 Interrupt                               */
     DCD      EXTI2_Handler        ;/*   5 (054H) EXTI2 Interrupt                               */
     DCD      EXTI3_Handler        ;/*   6 (058H) EXTI3 Interrupt                               */
     DCD      ADC_Handler          ;/*   7 (05CH) ADC Interrupt                                 */
     DCD      TWI0_Handler         ;/*   8 (060H) TWI0 Interrupt                                */
     DCD      TWI1_Handler         ;/*   9 (064H) TWI1 Interrupt                                */
     DCD      PCA0_Handler         ;/*  10 (068H) PCA0 Interrupt                                */
     DCD      PCA1_Handler         ;/*  11 (06CH) PCA1 Interrupt                                */
     DCD      PCA2_Handler         ;/*  12 (070H) PCA2 Interrupt                                */
     DCD      PCA3_Handler         ;/*  13 (074H) PCA3 Interrupt                                */
     DCD      EXTI9_4_Handler      ;/*  14 (078H) EXTI9_4 Interrupt                             */
     DCD      UART0_Handler        ;/*  15 (07CH) UART0 Interrupt                               */
     DCD      SPI0_Handler         ;/*  16 (080H) SPI0 Interrupt                                */
     DCD      SPI1_Handler         ;/*  17 (084H) SPI1 Interrupt                                */
     DCD      UART1_Handler        ;/*  18 (088H) UART1 Interrupt                               */
     DCD      UART2_Handler        ;/*  19 (08CH) UART2 Interrupt                               */
     DCD      UART3_Handler        ;/*  20 (090H) UART3 Interrupt                               */
     DCD      EXTI15_10_Handler    ;/*  21 (094H) EXTI15_10 Interrupt                           */
     DCD      UART4_Handler        ;/*  22 (098H) UART4 Interrupt                               */
     DCD      UART5_Handler        ;/*  23 (09CH) UART5 Interrupt                               */
     DCD      PWM0_Handler         ;/*  24 (0A0H) PWM0 Interrupt                                */
     DCD      PWM1_Handler         ;/*  25 (0A4H) PWM1 Interrupt                                */
     DCD      PWM2_Handler         ;/*  26 (0A8H) PWM2 Interrupt                                */
     DCD      PWM3_Handler         ;/*  27 (0ACH) PWM3 Interrupt                                */
     DCD      TIM0_Handler         ;/*  28 (0B0H) TIM0 Interrupt                                */
     DCD      TIM1_FIFO0_Handler   ;/*  29 (0B4H) TIM1_FIFO0 Interrupt                          */
     DCD      TIM2_FIFO1_Handler   ;/*  30 (0B8H) TIM2_FIFO1 Interrupt                          */
     DCD      TIM3_FIFO2_Handler   ;/*  31 (0BCH) TIM3_FIFO2 Interrupt                          */


    THUMB
    PUBWEAK Reset_Handler
    SECTION .text:CODE:REORDER:NOROOT(2)
Reset_Handler
    
    LDR     R0, =SystemInit
    BLX     R0
    LDR     R0, =__iar_program_start
    BX      R0
    
    PUBWEAK SystemInit
    SECTION .text:CODE:REORDER:NOROOT(1)
SystemInit
    BX LR
    
    PUBWEAK NMI_Handler
    SECTION .text:CODE:REORDER:NOROOT(1)
NMI_Handler
    B NMI_Handler    

    PUBWEAK HardFault_Handler
    SECTION .text:CODE:REORDER:NOROOT(1)
HardFault_Handler
    B HardFault_Handler
    
    PUBWEAK MemManage_Handler
    SECTION .text:CODE:REORDER:NOROOT(1)
MemManage_Handler
    B MemManage_Handler

    PUBWEAK BusFault_Handler
    SECTION .text:CODE:REORDER:NOROOT(1)
BusFault_Handler
    B BusFault_Handler

    PUBWEAK UsageFault_Handler
    SECTION .text:CODE:REORDER:NOROOT(1)
UsageFault_Handler
    B UsageFault_Handler

    PUBWEAK SVC_Handler
    SECTION .text:CODE:REORDER:NOROOT(1)
SVC_Handler
    B SVC_Handler

    PUBWEAK DebugMon_Handler
    SECTION .text:CODE:REORDER:NOROOT(1)
DebugMon_Handler
    B DebugMon_Handler

    PUBWEAK PendSV_Handler
    SECTION .text:CODE:REORDER:NOROOT(1)
PendSV_Handler
    B PendSV_Handler

    PUBWEAK SysTick_Handler
    SECTION .text:CODE:REORDER:NOROOT(1)
SysTick_Handler
    B SysTick_Handler
    
                    
    PUBWEAK    WWDT_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
WWDT_Handler        
    B WWDT_Handler        
    PUBWEAK    BOD_Handler         
    SECTION .text:CODE:REORDER:NOROOT(1)
BOD_Handler         
    B BOD_Handler         
    PUBWEAK    RCC_Handler         
    SECTION .text:CODE:REORDER:NOROOT(1)
RCC_Handler         
    B RCC_Handler         
    PUBWEAK    EXTI0_Handler       
    SECTION .text:CODE:REORDER:NOROOT(1)
EXTI0_Handler       
    B EXTI0_Handler       
    PUBWEAK    EXTI1_Handler       
    SECTION .text:CODE:REORDER:NOROOT(1)
EXTI1_Handler       
    B EXTI1_Handler       
    PUBWEAK    EXTI2_Handler       
    SECTION .text:CODE:REORDER:NOROOT(1)
EXTI2_Handler       
    B EXTI2_Handler       
    PUBWEAK    EXTI3_Handler       
    SECTION .text:CODE:REORDER:NOROOT(1)
EXTI3_Handler       
    B EXTI3_Handler       
    PUBWEAK    ADC_Handler         
    SECTION .text:CODE:REORDER:NOROOT(1)
ADC_Handler         
    B ADC_Handler         
    PUBWEAK    TWI0_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
TWI0_Handler        
    B TWI0_Handler        
    PUBWEAK    TWI1_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
TWI1_Handler        
    B TWI1_Handler        
    PUBWEAK    PCA0_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
PCA0_Handler        
    B PCA0_Handler        
    PUBWEAK    PCA1_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
PCA1_Handler        
    B PCA1_Handler        
    PUBWEAK    PCA2_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
PCA2_Handler        
    B PCA2_Handler        
    PUBWEAK    PCA3_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
PCA3_Handler        
    B PCA3_Handler        
    PUBWEAK    EXTI9_4_Handler     
    SECTION .text:CODE:REORDER:NOROOT(1)
EXTI9_4_Handler     
    B EXTI9_4_Handler     
    PUBWEAK    UART0_Handler       
    SECTION .text:CODE:REORDER:NOROOT(1)
UART0_Handler       
    B UART0_Handler       
    PUBWEAK    SPI0_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
SPI0_Handler        
    B SPI0_Handler        
    PUBWEAK    SPI1_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
SPI1_Handler        
    B SPI1_Handler        
    PUBWEAK    UART1_Handler       
    SECTION .text:CODE:REORDER:NOROOT(1)
UART1_Handler       
    B UART1_Handler       
    PUBWEAK    UART2_Handler       
    SECTION .text:CODE:REORDER:NOROOT(1)
UART2_Handler       
    B UART2_Handler       
    PUBWEAK    UART3_Handler       
    SECTION .text:CODE:REORDER:NOROOT(1)
UART3_Handler       
    B UART3_Handler       
    PUBWEAK    EXTI15_10_Handler   
    SECTION .text:CODE:REORDER:NOROOT(1)
EXTI15_10_Handler   
    B EXTI15_10_Handler   
    PUBWEAK    UART4_Handler       
    SECTION .text:CODE:REORDER:NOROOT(1)
UART4_Handler       
    B UART4_Handler       
    PUBWEAK    UART5_Handler       
    SECTION .text:CODE:REORDER:NOROOT(1)
UART5_Handler       
    B UART5_Handler       
    PUBWEAK    PWM0_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
PWM0_Handler        
    B PWM0_Handler        
    PUBWEAK    PWM1_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
PWM1_Handler        
    B PWM1_Handler        
    PUBWEAK    PWM2_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
PWM2_Handler        
    B PWM2_Handler        
    PUBWEAK    PWM3_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
PWM3_Handler        
    B PWM3_Handler        
    PUBWEAK    TIM0_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
TIM0_Handler        
    B TIM0_Handler        
    PUBWEAK    TIM1_FIFO0_Handler  
    SECTION .text:CODE:REORDER:NOROOT(1)
TIM1_FIFO0_Handler  
    B TIM1_FIFO0_Handler  
    PUBWEAK    TIM2_FIFO1_Handler  
    SECTION .text:CODE:REORDER:NOROOT(1)
TIM2_FIFO1_Handler  
    B TIM2_FIFO1_Handler  
    PUBWEAK    TIM3_FIFO2_Handler  
    SECTION .text:CODE:REORDER:NOROOT(1)
TIM3_FIFO2_Handler  
    B TIM3_FIFO2_Handler  
    
    PUBWEAK Default_Handler
    SECTION .text:CODE:REORDER:NOROOT(1)
Default_Handler
    B Default_Handler
    
    END
/*********************** (C) COPYRIGHT SINOWEALTH *** END OF FILE**********/

