/**
 * @file      sh30f9xx_sb0_main.c
 * @brief     temp project
 * @author    sinowealth software group ()
 * @date      2025-03-10
 * @version   V1.0
 * @copyright Copyright (c) 1994 - 2025 SINOWEALTH Electronic Ltd.
 * 
 * @attention
 * SINOWEALTH IS SUPPLYING THIS SOFTWARE FOR USE EXCLUSIVELY ON SINOWEALTH'S
 * MICROCONTROLLER PRODUCTS. IT IS PROTECTED UNDER APPLICABLE COPYRIGHT LAWS. 
 * THIS SOFTWARE IS FOR GUIDANCE IN ORDER TO SAVE TIME. AS A RESULT, SINOWEALTH 
 * SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES 
 * WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT OF SUCH FIRMWARE AND/OR
 * THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN 
 * CONNECTION WITH THEIR PRODUCTS.
 * @par Change log:
 * <table>
 * <tr><th>Date        <th>Version  <th>Author    <th>Description
 * <tr><td>2025-03-10  <td>1.0      <td>bruce     <td>Create initial version
 * </table>
 */

#include "sh30f9xx_sb0.h"
#include "sh30f9xx_sb0_retarget.h"

/**
 * @brief  Main function
 * @param  None
 * @retval None
 */
int main(void)
{
    HWDT_ConfigPeriod(HWDT_ReloadPeriod_2048MS);
#ifdef _MODULE_DBG_PRINTF
    RetargetInit();
    printf("Welcome to use SINOWEALTH device!\n");
#endif

    /* Infinite loop */
    while (1)
    {
        HWDT_ReloadCounter();
    }
}

/******************* (C) COPYRIGHT Sinowealth *****END OF FILE************/
